=== 3rdparty/zlib-ng/CMakeLists.txt ===
project(${ZLIB_LIBRARY} LANGUAGES C)

if("c_std_11" IN_LIST CMAKE_C_COMPILE_FEATURES)
  set(CMAKE_C_STANDARD 11)          # The C standard whose features are requested to build this target
else()
  set(CMAKE_C_STANDARD 99)
endif()
set(CMAKE_C_STANDARD_REQUIRED ON) # Boolean describing whether the value of C_STANDARD is a requirement
set(CMAKE_C_EXTENSIONS OFF)       # Boolean specifying whether compiler specific extensions are requested

include(CheckTypeSize)
include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CMakeDependentOption)

if(X86_64 OR X86)
  set(BASEARCH_X86_FOUND TRUE)
endif()
if(AARCH64 OR ARM)
  set(BASEARCH_ARM_FOUND TRUE)
endif()
if(PPC64LE OR PPC64)
  set(BASEARCH_PPC_FOUND TRUE)
endif()
if(RISCV)
  set(BASEARCH_RISCV_FOUND TRUE)
endif()

include(cmake/detect-intrinsics.cmake)
include(cmake/fallback-macros.cmake)

set(ZLIB_SYMBOL_PREFIX "")

if(BASEARCH_X86_FOUND)
  set(WITH_AVX2 ON)
  set(WITH_AVX512 ON)
  set(WITH_AVX512VNNI ON)
  set(WITH_SSE2 ON)
  set(WITH_SSSE3 ON)
  set(WITH_SSE42 ON)
  set(WITH_PCLMULQDQ ON)
  set(WITH_VPCLMULQDQ ON)
endif()
if(BASEARCH_ARM_FOUND)
  set(WITH_ACLE ON)
  set(WITH_NEON ON)
  if(ARM)
    set(WITH_ARMV6 ON)
  else()
    set(WITH_ARMV6 OFF)
  endif()
endif()
if(BASEARCH_PPC_FOUND)
  set(WITH_ALTIVEC ON)
  set(WITH_POWER8 ON)
  set(WITH_POWER9 ON)
endif()
if(BASEARCH_RISCV_FOUND)
  set(WITH_RVV ON)
endif()


add_definitions(-DZLIB_COMPAT)

add_definitions(-DWITH_GZFILEOP)

if(CMAKE_C_COMPILER_ID MATCHES "^Intel")
  set(WARNFLAGS_DISABLE)
elseif(MSVC)
  # Minimum supported MSVC version is 1800 = Visual Studio 12.0/2013
  # See also https://cmake.org/cmake/help/latest/variable/MSVC_VERSION.html
  if(MSVC_VERSION VERSION_LESS 1800)
    message(SEND_ERROR "Unsupported Visual Studio compiler version (requires 2013 or later).")
  endif()
  # TODO. ICC can be used through MSVC. I'm not sure if we'd ever see that combination
  # (who'd use cmake from an IDE...) but checking for ICC before checking for MSVC should
  # avoid mistakes.
  # /Oi ?
  set(WARNFLAGS_DISABLE)
  if(BASEARCH_ARM_FOUND)
      add_definitions(-D_ARM_WINAPI_PARTITION_DESKTOP_SDK_AVAILABLE)
      if(NOT "${ARCH}" MATCHES "aarch64")
          set(NEONFLAG "/arch:VFPv4")
      endif()
  endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(WARNFLAGS_DISABLE)
  # Check whether -fno-lto is available
  set(CMAKE_REQUIRED_FLAGS "-fno-lto")
  check_c_source_compiles(
    "int main() { return 0; }"
    FNO_LTO_AVAILABLE FAIL_REGEX "not supported")
  set(CMAKE_REQUIRED_FLAGS)
  if(FNO_LTO_AVAILABLE)
    set(ZNOLTOFLAG "-fno-lto")
  endif()
  if(BASEARCH_ARM_FOUND)
    if(ARM AND NOT CMAKE_C_FLAGS MATCHES "-mfloat-abi")
      # Auto-detect support for ARM floating point ABI
      check_include_file(features.h HAVE_FEATURES_H)
      if(HAVE_FEATURES_H)
        set(CMAKE_REQUIRED_FLAGS -mfloat-abi=softfp)
        check_c_source_compiles(
          "#include <features.h>
          int main() { return 0; }"
          HAVE_FLOATABI_SOFTFP)
        if(HAVE_FLOATABI_SOFTFP)
          set(FLOATABI -mfloat-abi=softfp)
        else()
          set(CMAKE_REQUIRED_FLAGS -mfloat-abi=hard)
          check_c_source_compiles(
            "#include <features.h>
            int main() { return 0; }"
            HAVE_FLOATABI_HARD)
          if(HAVE_FLOATABI_HARD)
            set(FLOATABI -mfloat-abi=hard)
          endif()
        endif()
        set(CMAKE_REQUIRED_FLAGS)
      endif()
      if(FLOATABI)
        message(STATUS "${ZLIB_LIBRARY} ARM floating point arch: ${FLOATABI}")
        add_compile_options(${FLOATABI})
      else()
        message(STATUS "${ZLIB_LIBRARY} ARM floating point arch not auto-detected")
      endif()
    endif()
  endif()
  if(FNO_LTO_AVAILABLE)
    set(NOLTOFLAG ${ZNOLTOFLAG})
  endif()
  if(MINGW)
    # Add `-Wno-pedantic-ms-format` only if the toolchain supports it
    check_c_compiler_flag(-Wno-pedantic-ms-format HAVE_NO_PEDANTIC_MS_FORMAT)
    if(HAVE_NO_PEDANTIC_MS_FORMAT)
      list(APPEND WARNFLAGS_DISABLE -Wno-pedantic-ms-format)
    endif()
  endif()
endif()

# Force disable LTO
set(CMAKE_INTERPROCEDURAL_OPTIMIZATION OFF)

# Apply warning compiler flags
add_compile_options(${WARNFLAGS_DISABLE})

# Replace optimization level 3 added by default with level 2
if(NOT MSVC AND NOT CMAKE_C_FLAGS MATCHES "([\\/\\-]O)3")
  string(REGEX REPLACE "([\\/\\-]O)3" "\\12"
    CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

#
# Check for standard/system includes
#
check_include_file(arm_acle.h  HAVE_ARM_ACLE_H)
if(HAVE_ARM_ACLE_H)
  add_definitions(-DHAVE_ARM_ACLE_H)
endif()
check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
if(HAVE_SYS_AUXV_H)
  add_definitions(-DHAVE_SYS_AUXV_H)
endif()
check_include_file(sys/sdt.h   HAVE_SYS_SDT_H)
if(HAVE_SYS_SDT_H)
  add_definitions(-DHAVE_SYS_SDT_H)
endif()
check_include_file(unistd.h    HAVE_UNISTD_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1 -D__USE_LARGEFILE64)
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
  add_definitions(-D_LARGEFILE64_SOURCE=1 -D__USE_LARGEFILE64)
else()
  check_type_size(_off64_t _OFF64_T)
  if(HAVE__OFF64_T)
    add_definitions(-D_LARGEFILE64_SOURCE=1 -D__USE_LARGEFILE64)
  else()
    check_type_size(__off64_t __OFF64_T)
  endif()
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko and other optional functions
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
  add_definitions(-DNO_FSEEKO)
endif()

check_function_exists(strerror HAVE_STRERROR)
if(NOT HAVE_STRERROR)
  add_definitions(-DNO_STRERROR)
endif()

set(CMAKE_REQUIRED_DEFINITIONS -D_POSIX_C_SOURCE=200112L)
check_symbol_exists(posix_memalign stdlib.h HAVE_POSIX_MEMALIGN)
if(HAVE_POSIX_MEMALIGN)
  add_definitions(-DHAVE_POSIX_MEMALIGN)
endif()
set(CMAKE_REQUIRED_DEFINITIONS)

set(CMAKE_REQUIRED_DEFINITIONS -D_ISOC11_SOURCE=1)
check_symbol_exists(aligned_alloc stdlib.h HAVE_ALIGNED_ALLOC)
if(HAVE_ALIGNED_ALLOC)
  add_definitions(-DHAVE_ALIGNED_ALLOC)
endif()
set(CMAKE_REQUIRED_DEFINITIONS)

#
# Check if we can hide zlib internal symbols that are linked between separate source files using hidden
#
check_c_source_compiles(
  "#define Z_INTERNAL __attribute__((visibility (\"hidden\")))
  int Z_INTERNAL foo;
  int main() {
      return 0;
  }"
  HAVE_ATTRIBUTE_VISIBILITY_HIDDEN FAIL_REGEX "visibility")
if(HAVE_ATTRIBUTE_VISIBILITY_HIDDEN)
  add_definitions(-DHAVE_VISIBILITY_HIDDEN)
endif()

#
# Check if we can hide zlib internal symbols that are linked between separate source files using internal
#
check_c_source_compiles(
  "#define Z_INTERNAL __attribute__((visibility (\"internal\")))
  int Z_INTERNAL foo;
  int main() {
      return 0;
  }"
  HAVE_ATTRIBUTE_VISIBILITY_INTERNAL FAIL_REGEX "visibility")
if(HAVE_ATTRIBUTE_VISIBILITY_INTERNAL)
  add_definitions(-DHAVE_VISIBILITY_INTERNAL)
endif()

#
# Check for __attribute__((aligned(x))) support in the compiler
#
check_c_source_compiles(
  "int main(void) {
      __attribute__((aligned(8))) int test = 0;
      (void)test;
      return 0;
  }"
  HAVE_ATTRIBUTE_ALIGNED FAIL_REGEX "aligned")
if(HAVE_ATTRIBUTE_ALIGNED)
  add_definitions(-DHAVE_ATTRIBUTE_ALIGNED)
endif()

#
# check for __builtin_ctz() support in the compiler
#
check_c_source_compiles(
  "int main(void) {
      unsigned int zero = 0;
      long test = __builtin_ctz(zero);
      (void)test;
      return 0;
  }"
  HAVE_BUILTIN_CTZ
)
if(HAVE_BUILTIN_CTZ)
  add_definitions(-DHAVE_BUILTIN_CTZ)
endif()

#
# check for __builtin_ctzll() support in the compiler
#
check_c_source_compiles(
  "int main(void) {
      unsigned int zero = 0;
      long test = __builtin_ctzll(zero);
      (void)test;
      return 0;
  }"
  HAVE_BUILTIN_CTZLL
)
if(HAVE_BUILTIN_CTZLL)
  add_definitions(-DHAVE_BUILTIN_CTZLL)
endif()

#
# check for ptrdiff_t support
#
check_c_source_compiles(
  "#include <stddef.h>
    int main() {
        ptrdiff_t *a;
        (void)a;
        return 0;
  }"
  HAVE_PTRDIFF_T
)
if(NOT HAVE_PTRDIFF_T)
  set(NEED_PTRDIFF_T 1)

  check_type_size("void *" SIZEOF_DATA_PTR)
  message(STATUS "sizeof(void *) is ${SIZEOF_DATA_PTR} bytes")

  if(${SIZEOF_DATA_PTR} MATCHES "4")
    set(PTRDIFF_TYPE "uint32_t")
  elseif(${SIZEOF_DATA_PTR} MATCHES "8")
    set(PTRDIFF_TYPE "uint64_t")
  else()
    message(FATAL_ERROR "sizeof(void *) is neither 32 nor 64 bit")
  endif()
endif()

if(MSVC)
  add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

set(ZLIB_ARCH_SRCS)
set(ZLIB_ARCH_HDRS)
set(ARCHDIR "arch/generic")
if(BASEARCH_X86_FOUND)
  set(ARCHDIR "arch/x86")
endif()
if(BASEARCH_ARM_FOUND)
  set(ARCHDIR "arch/arm")
endif()
if(BASEARCH_PPC_FOUND)
  set(ARCHDIR "arch/power")
endif()
if(BASEARCH_RISCV_FOUND)
  set(ARCHDIR "arch/riscv")
endif()

if(NOT CV_DISABLE_OPTIMIZATION)
  if(BASEARCH_ARM_FOUND)
    add_definitions(-DARM_FEATURES)
    if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
      if("${ARCH}" MATCHES "aarch64")
        check_c_source_compiles(
          "#include <sys/auxv.h>
          int main() {
              return (getauxval(AT_HWCAP) & HWCAP_CRC32);
          }"
          ARM_AUXV_HAS_CRC32
        )
        if(ARM_AUXV_HAS_CRC32)
          add_definitions(-DARM_AUXV_HAS_CRC32)
        else()
          message(STATUS "HWCAP_CRC32 not present in sys/auxv.h; cannot detect support at runtime.")
        endif()
      else()
        check_c_source_compiles(
          "#include <sys/auxv.h>
          int main() {
              return (getauxval(AT_HWCAP2) & HWCAP2_CRC32);
          }"
          ARM_AUXV_HAS_CRC32
        )
        if(ARM_AUXV_HAS_CRC32)
          add_definitions(-DARM_AUXV_HAS_CRC32)
        else()
          check_c_source_compiles(
            "#include <sys/auxv.h>
            #include <asm/hwcap.h>
            int main() {
                return (getauxval(AT_HWCAP2) & HWCAP2_CRC32);
            }"
            ARM_HWCAP_HAS_CRC32
          )
          if(ARM_HWCAP_HAS_CRC32)
            add_definitions(-DARM_AUXV_HAS_CRC32 -DARM_ASM_HWCAP)
          else()
            message(STATUS "HWCAP2_CRC32 not present in sys/auxv.h; cannot detect support at runtime.")
          endif()
        endif()
        check_c_source_compiles(
          "#include <sys/auxv.h>
          int main() {
            return (getauxval(AT_HWCAP) & HWCAP_ARM_NEON);
          }"
          ARM_AUXV_HAS_NEON
        )
        if(ARM_AUXV_HAS_NEON)
          add_definitions(-DARM_AUXV_HAS_NEON)
        else()
          check_c_source_compiles(
            "#include <sys/auxv.h>
            int main() {
              return (getauxval(AT_HWCAP) & HWCAP_NEON);
            }"
            ARM_AUXV_HAS_NEON
          )
          if (ARM_AUXV_HAS_NEON)
            add_definitions(-DARM_AUXV_HAS_NEON)
          else()
            message(STATUS "Neither HWCAP_ARM_NEON or HWCAP_NEON present in sys/auxv.h; cannot detect support at runtime.")
          endif()
        endif()
      endif()
    endif()
    list(APPEND ZLIB_ARCH_HDRS ${ARCHDIR}/arm_features.h)
    list(APPEND ZLIB_ARCH_SRCS ${ARCHDIR}/arm_features.c)
    if(WITH_ACLE)
      check_acle_compiler_flag()
      if(HAVE_ACLE_FLAG)
        add_definitions(-DARM_ACLE)
        set(ACLE_SRCS ${ARCHDIR}/crc32_acle.c ${ARCHDIR}/insert_string_acle.c)
        set_property(SOURCE ${ACLE_SRCS} PROPERTY COMPILE_FLAGS "${ACLEFLAG} ${NOLTOFLAG}")
        list(APPEND ZLIB_ARCH_SRCS ${ACLE_SRCS})
      else()
        set(WITH_ACLE OFF)
      endif()
    else()
      set(WITH_ACLE OFF)
    endif()
    if(WITH_NEON)
      check_neon_compiler_flag()
      if(NEON_AVAILABLE)
        add_definitions(-DARM_NEON)
        set(NEON_SRCS ${ARCHDIR}/adler32_neon.c ${ARCHDIR}/chunkset_neon.c
          ${ARCHDIR}/compare256_neon.c ${ARCHDIR}/slide_hash_neon.c)
        list(APPEND ZLIB_ARCH_SRCS ${NEON_SRCS})
