=== modules/img_hash/CMakeLists.txt ===
set(the_description "Image hash algorithms")
set(OPENCV_MODULE_IS_PART_OF_WORLD OFF)
ocv_define_module(img_hash opencv_imgproc opencv_core WRAP python java objc)
